## ОпределениеАннотации

* [Назад](./index.md)

### ПриСозданииОбъекта

```bsl

Процедура ПриСозданииОбъекта(Знач _Имя, Знач _ИмяТипаАннотации, Знач _Параметры, Знач _Аннотации) 
```

### Имя

```bsl
// Имя аннотации.
//
//  Возвращаемое значение:
//   Строка
//
Функция Имя() 
```

### ИмяТипаАннотации

```bsl
// Имя типа, к которому применяется аннотация.
//
//  Возвращаемое значение:
//   Строка
//
Функция ИмяТипаАннотации() 
```

### Параметры

```bsl
// Параметры аннотации - разобранные параметры конструктора класса аннотации.
// Метод возвращает копию таблицы.
//
//  Возвращаемое значение:
//   ТаблицаЗначений - таблица параметров аннотации:
//     * Имя                     - Строка          - Имя параметра.
//     * ПоЗначению              - Булево          - Признак получения пораметра по значению.
//     * ЕстьЗначениеПоУмолчанию - Булево          - Признак наличия значения по умолчанию.
//     * ЗначениеПоУмолчанию     - Произвольный    - Значение по умолчанию.
//     * Аннотации               - ТаблицаЗначений - Таблица аннотаций со следующими колонками:
//        ** Имя       - Строка          - Имя аннотации.
//        ** Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//           *** Имя      - Строка - Имя параметра аннотации.
//           *** Значение - Строка - Значение параметра аннотации.
//     * Экспорт                 - Булево          - Признак экспорта параметра.
//
Функция Параметры() 
```

### Аннотации

```bsl
// Подчиненные аннотации - список аннотаций над конструктором класса-аннотации.
// Метот возвращает глубокую копию таблицы.
//
//  Возвращаемое значение:
//   ТаблицаЗначений - Таблица аннотаций:
//     * Имя       - Строка          - Имя аннотации.
//     * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//       ** Имя      - Строка - Имя параметра аннотации.
//       ** Значение - Строка - Значение параметра аннотации.
//
Функция Аннотации() 
```

### Проверить

```bsl
// Выполнить проверку корректности аннотации.
//
// Выбрасывает исключение:
//  * Когда аннотация не содержит параметр, у которого нет значения по умолчанию.
//  * Когда аннотация содержит параметр, которого нет в списке параметров аннотации.
//  * Когда аннотация содержит несколько параметров без имени или с именем "Значение".
//
// Параметры:
//   Аннотация - СтрокаТаблицыЗначений - Данные аннотации:
//     * Имя       - Строка          - Имя аннотации.
//     * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//       ** Имя      - Строка - Имя параметра аннотации.
//       ** Значение - Строка - Значение параметра аннотации.
//   ИмяТипаСАннотацией - Строка - Имя типа, к которому применяется аннотация.
//
Процедура Проверить(Аннотация, ИмяТипаСАннотацией) 
```

### СоздатьОбъектАннотации

```bsl
// Создать объект класса аннотации по параметрам аннотации.
//
// Параметры:
//   Аннотация - СтрокаТаблицыЗначений - Данные аннотации:
//     * Имя       - Строка          - Имя аннотации.
//     * Параметры - ТаблицаЗначений - Таблица параметров аннотации:
//       ** Имя      - Строка - Имя параметра аннотации.
//       ** Значение - Строка - Значение параметра аннотации.
//
// Возвращаемое значение:
//   Произвольный - Объект аннотации с заданными параметрами.
//
Функция СоздатьОбъектАннотации(Аннотация) 
```

